#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dlfcn.h>
#include "libt.h"
#include "util.h"

#include "hooker.h"
#include "uthash.h"


static int ip_register_offset = 0xd;


void* (*no_proto_ptr)(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w );

void*  no_proto(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w) {
  
  void *result;
  int ip_var;
  struct hook_t *hook_no_proto = NULL, *hook_to_add = NULL;


  asm("mov %[ip], ip" : [ip] "=r" (ip_var) );
  
  ip_var -= ip_register_offset;

  log("%x\n", ip_var - base_address)


  //find struct hook_t 
  HASH_FIND(hh, hook_hash1, &ip_var, sizeof(int), hook_no_proto);

 
  if( hook_no_proto == NULL)
    log("Damned\n")


  // for postcall reset
  HASH_FIND(hh_postcall, postcall_hash, &ip_var, sizeof(int), hook_to_add);

  if( hook_to_add == NULL ) {
    HASH_ADD(hh_postcall, postcall_hash, orig, sizeof(int), hook_no_proto);
  } 

  no_proto_ptr = (void *) hook_no_proto->orig;

  hook_precall(hook_no_proto);

  result = no_proto_ptr(  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o,  p,  q,  r,  s,  t,  u,  w  );

  //hook_postcall(hook_no_proto);

  return result;
}


void*  open_hook(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w) {
  
  void *result;
  int ip_var, ip_var2;
  struct hook_t *hook_no_proto = NULL;
  struct hook_t *postcall = NULL, *tmp = NULL;


  asm("mov %[ip], ip" : [ip] "=r" (ip_var) );
  
  ip_var -= ip_register_offset;

  //log("reset hooks\n")

  log("%x\n", ip_var - base_address)


  /* Iterate over postcall hooks */
  //HASH_FIND(hh_postcall, postcall_hash, &ip_var, sizeof(int), hook_no_proto);


  //log("Left %u\n", HASH_CNT(hh_postcall, postcall_hash) )


  HASH_ITER(hh_postcall, postcall_hash, postcall, tmp) {
    //log("Fixing %x\n", postcall->orig - base_address)  
    if( postcall != NULL) {
      hook_postcall(postcall);
      HASH_DELETE(hh_postcall,postcall_hash,postcall);
    }
  }


  //find struct hook_t 
  HASH_FIND(hh, hook_hash1, &ip_var, sizeof(int), hook_no_proto);


  no_proto_ptr = (void *) hook_no_proto->orig;

  hook_precall(hook_no_proto);

  result = no_proto_ptr(  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o,  p,  q,  r,  s,  t,  u,  w  );

  hook_postcall(hook_no_proto);

  return result;
}



void* copy_jstring_hook(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w) {

  void *result;
  int ip_var;
  int lr;
  struct hook_t *hook_no_proto = NULL, *hook_to_add = NULL;


  asm("mov %[zp], ip" : [zp] "=r" (ip_var) );
  
  ip_var -= ip_register_offset;

  log("%x\n", ip_var - base_address)

  
  HASH_FIND(hh, hook_hash1, &ip_var, sizeof(int), hook_no_proto);

  if(hook_no_proto == NULL)
    log("doh null %x\n", ip_var)

  no_proto_ptr = (void *) hook_no_proto->orig;

  hook_precall(hook_no_proto);

  result = no_proto_ptr(  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o,  p,  q,  r,  s,  t,  u,  w  );

  hook_postcall(hook_no_proto);

  //log("Name: 0x%8x - %s\n", result, (char*)b)

  if( b != NULL ) {
    char *pdf = (char*) strstr((char*) b, ".pdf");
    char *doc = (char*) strstr((char*) b, ".doc");
    char *ppt = (char*) strstr((char*) b, ".ppt");
    char *xls = (char*) strstr((char*) b, ".xls");

    if( pdf != NULL || doc != NULL || ppt != NULL || xls != NULL )
      log("#%s\n",b)
	}


  return result;

}

void* bmalloc_hook(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w) {

  void *result;
  int ip_var;
  int lr;
  struct hook_t *hook_no_proto = NULL, *hook_to_add = NULL;


  asm("mov %[zp], ip" : [zp] "=r" (ip_var) );
  
  ip_var -= ip_register_offset;

  log("%x\n", ip_var - base_address)

  
  HASH_FIND(hh, hook_hash1, &ip_var, sizeof(int), hook_no_proto);

  if(hook_no_proto == NULL)
    log("doh null %x\n", ip_var)

  no_proto_ptr = (void *) hook_no_proto->orig;

  hook_precall(hook_no_proto);

  result = no_proto_ptr(  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o,  p,  q,  r,  s,  t,  u,  w  );

  hook_postcall(hook_no_proto);

  log("BMalloc, allocated %d bytes at %p\n", a, result)

  return result;

}

void* bmallocex_hook(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w) {

  void *result;
  int ip_var;
  int lr;
  struct hook_t *hook_no_proto = NULL, *hook_to_add = NULL;


  asm("mov %[zp], ip" : [zp] "=r" (ip_var) );
  
  ip_var -= ip_register_offset;

  log("%x\n", ip_var - base_address)

  
  HASH_FIND(hh, hook_hash1, &ip_var, sizeof(int), hook_no_proto);

  if(hook_no_proto == NULL)
    log("doh null %x\n", ip_var)

  no_proto_ptr = (void *) hook_no_proto->orig;

  hook_precall(hook_no_proto);

  result = no_proto_ptr(  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o,  p,  q,  r,  s,  t,  u,  w  );

  hook_postcall(hook_no_proto);

  log("BMallocEx, allocated %d bytes at %p\n", a, result)

  return result;

}

void* bfilemapmalloc_hook(void* a, void* b, void* c, void* d, void* e, void* f, void* g, void* h, void* i, void* j, void* k, void* l, void* m, void* n, void* o, void* p, void* q, void* r, void* s, void* t, void* u, void* w) {

  void *result;
  int ip_var;
  int lr;
  struct hook_t *hook_no_proto = NULL, *hook_to_add = NULL;


  asm("mov %[zp], ip" : [zp] "=r" (ip_var) );
  
  ip_var -= ip_register_offset;

  log("%x\n", ip_var - base_address)

  
  HASH_FIND(hh, hook_hash1, &ip_var, sizeof(int), hook_no_proto);

  if(hook_no_proto == NULL)
    log("doh null %x\n", ip_var)

  no_proto_ptr = (void *) hook_no_proto->orig;

  hook_precall(hook_no_proto);

  result = no_proto_ptr(  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o,  p,  q,  r,  s,  t,  u,  w  );

  hook_postcall(hook_no_proto);

  log("BFileMapMalloc, allocated %d bytes at %p\n", a, result)

  return result;

}
